echo ** Scala tutorial **
echo
echo Hello, this is the tutorial file that will guide you through
echo examples of some of the most commonly used commands in Scala.
echo The commands themselves will be written in capital letters.
echo
PAUSE
echo Let's begin with creating an equal temperament:
echo
SET PAUSE ON
SET ATTRIB CENTS
SET FIRST 0
echo EQUAL 13 3/1
echo This creates an equal tempered scale by dividing the perfect twelfth 
echo into 13 steps.
!
EQUAL 13 3/1
echo SHOW SCALE
SHOW SCALE
PAUSE
echo
echo You can also look at the consecutive intervals (the keyword SCALE can 
echo be omitted:
echo SHOW/INTERVAL
SHOW/INTERVAL
PAUSE
echo
echo Now let's create a Pythagorean scale:
echo PYTHAGOREAN
echo scale size: 12
echo octave: 2/1
echo degree of fifth: 0 (this is default and it means don't care)
echo fifth: 3/2
echo number of fifths downwards: 3 (this means going down to F Bb Eb)
PYTHAGOREAN
12
2/1
0
3/2
3
PAUSE
echo
echo SHOW
SHOW
PAUSE
echo
echo You can show it with note names instead of cents:
echo SET ATTRIB NOTATION
SET ATTRIB NOTATION E12
echo SHOW
SHOW
PAUSE
SET ATTRIB CENTS
echo
echo To see all the intervals in the scale, and how many there are of them:
echo SHOW INTERVALS
SHOW INTERVALS
PAUSE
echo
echo To see which are the frequencies of the scale:
echo SHOW/FREQUENCY
SHOW/FREQUENCY 
PAUSE
echo
echo The base frequency belonging to degree 0 of 1/1 can be changed,
echo like this:
echo SET FREQUENCY 256.0
echo
echo Or, it can be set relative to another degree of the current scale,
echo like this:
echo SET FREQUENCY 440.0 9
echo
echo We won't do that just now.
PAUSE
echo
echo Show several scale properties:
echo SHOW DATA
SHOW DATA
PAUSE
echo
echo See which modes of higher equal temperaments approximate the scale:
echo FIT/MODE
FIT/MODE
PAUSE
echo
echo To convert the current scale into a subset of an equal temperament use
echo the command QUANTIZE, for instance:
echo QUANTIZE 41
echo SHOW/INTERVAL
QUANTIZE 41
SHOW/INTERVAL
PAUSE
echo Let's see which octave based equal temperaments have a good approximation
echo to some interval.
echo Enter an interval now, for instance 7/6, then press RETURN:
echo DIVIDE/FIND
DIVIDE/FIND
?
PAUSE
echo
echo More than one scale can be kept in memory. The current one has number 0.
echo To copy the current one to memory 1, do
echo COPY 0 1
echo The command PUSH has the same effect.
COPY 0 1
PAUSE
echo
echo You can select a mode (subset) from a scale, for instance:
echo MODE M.Dorian
echo or do it directly without looking up a name: MODE 2 1 2 2 2 1 2
echo SHOW
MODE M.Dorian
SHOW
PAUSE
echo 
echo To undo this command we could do COPY 1 0, or POP, or UNDO.
echo To show scale 1 instead of the current scale you can do SHOW SCALE 1,
echo or even SHOW 1.
echo
echo To directly create a mode from its corresponding equal temperament (the
echo division equals the sum of the steps) we can do
echo MODE/EQUAL M.Dorian
echo SHOW
MODE/EQUAL M.Dorian
SHOW
PAUSE
echo
echo To change the key of a scale, we use the KEY command. For example when it's
echo moved to the fifth, it becomes the Aeolian mode. The fifth is at scale
echo degree 4, so we do
echo KEY 4
echo SHOW
echo You could also give the note name instead of degree number, since we've
echo already selected a notation system (E12):
echo KEY G
echo SHOW
KEY 4
SHOW
PAUSE
echo
echo The mode name can be checked by the following command. Since we know it's
echo a 12-tone mode, we do
echo FIT/MODE 12
FIT/MODE 12
PAUSE
echo
echo The first degree to be shown can be changed, for instance to omit 
echo degree 0 which is always 1/1, with
echo SET FIRST 1
SET FIRST 1
PAUSE
echo 
echo To see all settings like this one can do
echo SHOW SETTINGS
SHOW SETTINGS
PAUSE
echo
echo The current scale can be compared to scales on disk and in other memories
echo with COMPARE. This will show a number of things like when two scales are
echo the same, or the same except with respect to key, and which scale has the
echo least difference. The parameter is a file name mask. In practice one
echo should use CD first to change the directory to one's scale archive.
echo Let's compare the major scale in 12-tET.
echo MODE/EQUAL Ionian
MODE/EQUAL Ionian
echo COMPARE ptol*
COMPARE ptol*
PAUSE
echo
echo Now create a simple Euler-Fokker genus [33335], genus diatonicum
echo EULER
echo number of dimensions: 2
echo pitch 1: 3/2
echo multiplicity: 4
echo pitch 2: 5/4
echo multiplicity: 1
echo octave added: 2/1
EULER
2
3/2
4
5/4
1
2/1
SHOW
PAUSE
echo
echo Some pitches have become higher than an octave.
echo To bring them back within one octave we do:
echo REDUCE 2/1
echo But this leaves the scale in an unordered way. This requires:
echo SORT
echo This is the result:
REDUCE 2/1
SORT
SHOW
echo The reason that this is not done by the EULERFOKKER command is that one
echo might want to use another value than 2/1 for the octave. The command
echo REDUCE is an important one, and used in combination with more commands.
PAUSE
echo
echo To find out between which pairs of pitches a certain interval is 
echo (approximately) in the scale, do for instance:
echo SHOW LOCATION 4/3
SHOW LOCATION 4/3
PAUSE
echo
echo This can also be used to show the presence of chords, for example:
echo SHOW LOCATION 4:5:6
SHOW LOCATION 4:5:6
PAUSE
SET FIRST 0
echo
echo The value in the right column when a scale is shown can be changed by 
echo the SET ATTRIBUTE command. For instance to show the factorisation:
echo SET ATTRIBUTE PRIME
echo SHOW
SET ATTRIBUTE PRIME
SHOW
PAUSE
echo
echo Or to show string lengths, for instance with a used length of 500:
echo SET ATTRIBUTE RECIPROCAL 500.0
SET ATTRIBUTE RECIPROCAL 500.0
echo SHOW
SHOW
PAUSE
echo
echo Or to show note names, for example from 53-tone equal temperament:
echo SET ATTRIBUTE NOTATION E53
SET ATTRIBUTE NOTATION E53
echo SHOW
SHOW
PAUSE
echo
echo All attributes of a pitch value can be seen with one command, for 
echo example let's take 10/9:
echo SHOW/ATTRIBUTE PITCH 10/9
SHOW/ATTRIBUTE PITCH 10/9
PAUSE
echo
echo Inversion of a scale is the operation which reverses the order of the
echo scale steps, the intervals between successive tones. So the same steps
echo which occur in the downward direction are made in the upward direction
echo and vice versa. The command that does this is
echo INVERT
echo SHOW
INVERT
SHOW
PAUSE
echo You can see that the tones have all been replaced by their octave 
echo inversion.
echo
echo To change the number of tones in scale, the command EXTEND is provided.
echo The parameter is the new number of tones. When it's smaller than the
echo current size of the scale, the highest tones will be removed from the
echo scale. When it's higher, the size is increased by octave extension.
echo The last pitch is assumed to be the octave. So to double the size of the
echo current scale which has ten pitches, we do EXTEND 20.
PAUSE
EXTEND 20
SHOW
PAUSE
echo
echo There are more than 400 notation systems built in, these are their names:
echo SHOW NOTATION
PAUSE
SHOW NOTATION
PAUSE
echo
echo We can change the name for degree 0, 1/1, for example to A:
echo SET OFFSET A
SET OFFSET A
echo SHOW
SHOW
PAUSE
echo
echo Or to show intervals, like with SHOW/INTERVAL but then with another
echo interval class than 1, for example 4:
echo SET ATTRIBUTE INTERVAL 4
SET ATTRIBUTE INTERVAL 4
echo SHOW
SHOW
PAUSE
echo
echo We can also show this scale in the form of a lattice. This pictures the
echo scale structure in terms of fifths, thirds or other intervals like the
echo harmonic seventh.
echo The factors of 2 in the ratios shall be ignored.
echo Horizontally are the fifths (factor 3), vertically the major thirds (5).
echo LATTICE 3 5
LATTICE 3 5
echo
echo The 0 indicates the position of degree 0 with value 1/1.
echo Pseudo 3-dimensional lattices can also be shown, just add the third
echo interval as an extra parameter.
PAUSE
echo Instead of only asterisks, we can show the note names at their position.
echo LATTICE/NOTATION 3 5
LATTICE/NOTATION 3 5
echo
PAUSE
echo To create a so-called Novaro-Partch tonality diamond we use the command
echo SQUARE. The supplied factors will be the O- and U-tonalities. Let's create 
echo one with factors 1, 3, 5 and 7.
echo SQUARE
echo 4
echo 1
echo 3
echo 5
echo 7
SQUARE
4
1
3
5
7
PAUSE
echo
echo We can show this best in another lattice form which is the diamond lattice.
echo It shows the ratios in the numerator-denominator plane, also ignoring 
echo factors of 2:
echo LATTICE/DIAMOND
LATTICE/DIAMOND
echo
PAUSE
echo
echo Now we take 12-tone equal temperament.
echo EQUAL 12
EQUAL 12
echo To show beat frequencies of intervals on each degree, for example the
echo major third and perfect fifth, do:
echo SHOW BEATS 5/4 3/2
echo or the identical form: SHOW BEATS 4:5:6
PAUSE
SHOW BEATS 5/4 3/2
PAUSE
echo
echo We can also look at the temperings for these intervals, do:
echo SHOW TEMPERING 5/4 3/2
SHOW TEMPERING 5/4 3/2
PAUSE
echo
echo To calculate pitch values you can use the assignment operator ":=" and
echo the CALCULATE command. An arithmetical expression complete with 
echo parentheses can be given. This example calculates a quarter comma
echo tempered fifth and puts it in pitch memory 0:
echo $0:=3/2-$k\4
echo The symbol for pitch memory 0 is "$0", and a synonym for the syntonic
echo comma is "$k".
echo We could also have given $0:=3/2-81/80\4 or CALCULATE 3/2-81/80^1/4
echo Look at the next command for the value in pitch memory 0.
$0:=3/2-$k\4
PAUSE
echo
echo To see which scales and pitch memories are in use, do the command
echo CATALOGUE
CATALOGUE
PAUSE
echo
echo Scala can quickly calculate non-octave equal tempered scale approximations
echo to a set of (just) intervals. Create a scale with the intervals to be
echo approximated, for instance:
echo INPUT
echo 3
echo 7/6
echo 13/8
echo 7/4
INPUT
3
7/6
13/8
7/4
PAUSE
echo
echo Then issue the command FIT:
echo FIT
FIT
PAUSE
echo
echo The linear approximation is the approximation with consecutive scale
echo degrees, i.e. the first pitch is approximated by the given value times
echo one, the second by the given value times two, etc.
echo Next, different multiplication factors are given for each approximated 
echo pitch and on the line below the step size, how many of it is one octave
echo and the variance (root mean square of the differences).
PAUSE
echo
echo Commands that alter the current scale can be undone, but only the last
echo one. A copy of the previous contents of the current scale is kept in the
echo highest scale memory. The command that copies it back is:
echo UNDO
PAUSE
echo
echo Scala can calculate different properties of equal tempered scales.
echo For instance of 19-tET:
echo EQUAL/DATA 19 2/1
EQUAL/DATA 19 2/1
PAUSE
echo
echo Scala can find occurrences of predefined chords in a scale. Let's use the
echo Ptolemy major scale:
echo LOAD ptolemy
LOAD ptolemy
echo
echo We set the maximum deviation for a positive match to 2 cents:
echo SET MAXDIFF 2.0
SET MAXDIFF 2.0
PAUSE
echo And find chords at the 1/1 position 0 only:
echo CHORDS/MATCH/CONSTRAINED 0
CHORDS/MATCH/CONSTRAINED 0
PAUSE
echo
echo The predefined chords can be examined, for example we like to see all
echo chords with the word "dominant" in the name:
echo CHORDS/CENTS_SHOW dominant
CHORDS/CENTS_SHOW dominant
PAUSE
echo
echo
echo ** Tuning a synthesizer **
echo
echo If you have a MIDI instrument with a built-in tuning table, chance is it
echo can be tuned with Scala. Let's see which types are supported:
echo SHOW SYNTHESIZER
SHOW SYNTHESIZER
PAUSE
echo
echo Suppose we are the lucky owner of an Ensoniq ASR-X which can understand
echo the MIDI Tuning Standard bulk dump and have it connected via MIDI out to
echo our computer. Then to set this type:
echo SET SYNTHESIZER 107
SET SYNTHESIZER 107
PAUSE
echo
echo We can send the current scale to it by simply typing:
echo SEND
echo
echo Which we won't do right now. You need to set this up first. The SEND
echo command invokes a command script "send.cmd" which on its turn starts the
echo external program Megamid after creating a MIDI file with the tuning. 
echo When Megamid is used for the first time it needs to be told the MIDI out 
echo device (click on the Setup button in Megamid).
echo If you want to use another MIDI file player you can edit the "send.cmd"
echo script.
echo
echo Now we will load the 1/4-comma meantone scale and see instead what are the 
echo numbers that would be sent to the synth by sending them to the screen:
echo LOAD meanquar
echo SEND/SCREEN
SET OFFSET C
SET NOTATION E12
LOAD meanquar
PAUSE
SEND/SCREEN
PAUSE
echo 
echo Suppose we wish a different base frequency for this tuning dump. This is
echo not done with the command SET FREQUENCY we saw earlier, but with this:
echo SET MAP_FREQ 264.0
SET MAP_FREQ 264.0
PAUSE
echo
echo The settings about the relation of scales and MIDI are contained in the
echo current keyboard mapping. Let's see it:
echo SHOW MAPPING
SHOW MAPPING
PAUSE
echo
echo You could check the effect of the frequency change on the tuning numbers 
echo by doing SEND/SCREEN again.
echo
echo There are many more things that can be done with Scala than can be shown
echo in a short example file. Try them out. For instance you can now try
echo saving and loading a scale.
echo
echo Do HELP SHOW to see which other information can be produced; do
echo HELP SET for a list of settings that can be changed, and invoke HELP for
echo the other topics listed.
echo
echo Type TIP to get a tip-of-the-day:
echo TIP
TIP
PAUSE
echo
echo Good luck!
!
! Reset things to startup values
!
SET INT_STEPS -1
SET MAXDIFF 0.0
SET ATTRIBUTE CENTS
SET PAUSE OFF
